package com.tzld.piaoquan.recommend.server.service.score;

import com.google.common.reflect.TypeToken;
import com.tzld.piaoquan.recommend.server.service.score.model.XGBoostModel;
import com.tzld.piaoquan.recommend.server.util.JSONUtils;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.collections4.MapUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;


public abstract class BaseXGBoostModelScorer extends AbstractScorer {

    private static Logger LOGGER = LoggerFactory.getLogger(BaseXGBoostModelScorer.class);

    public BaseXGBoostModelScorer(ScorerConfigInfo scorerConfigInfo) {
        super(scorerConfigInfo);
    }

    @Override
    public void loadModel() {
        doLoadModel(XGBoostModel.class);
        XGBoostModel model = (XGBoostModel) this.getModel();
        Map<String, String> paramMap = scorerConfigInfo.getParamMap();
        if (MapUtils.isNotEmpty(paramMap)) {
            model.setFeatures(JSONUtils.fromJson(paramMap.get("features"), new TypeToken<String[]>() {
            }, null));
        }


    }
}
